# -*- text -*-

----------------------------------------------------------------------

Changes: V5.9.4 -> V5.9.5

commit 917f17c0b363273c048b97279093b4470dac39a1
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Sat Dec 20 06:37:43 2025 -0800

    Version number update: 5.9.5

commit 43da3ad35ace5d28e71212dd31c18ef9b6ba4726
Author: Andreas Hasenkopf <andreas.hasenkopf@checkmk.com>
Date:   Fri Nov 7 11:19:38 2025 +0100

    Fix segfaults when `varbind` cannot be constructed
    
    For multiple reasons, `varbind` can be a null pointer, which causes segmentation faults.
    
    With this change, the value is checked and the segmentation fault avoided.
    
    Co-authored-by: kain88-de <max.linke@checkmk.com>
    Co-authored-by: spt29 <sven.panne@checkmk.com>

commit 67d0989141ff4697a57afe16aa99afee0588ebed
Author: Kuzin Andrey <kuzinandrey@yandex.ru>
Date:   Tue Nov 11 16:26:24 2025 +0300

    Fix: Unused variable warning in cpu_linux.c
    
    mibgroup/hardware/cpu/cpu_linux.c: In function 'init_cpu_linux':
    mibgroup/hardware/cpu/cpu_linux.c:40:22: warning: unused variable 'cp' [-Wunused-variable]
       40 |     char buf[1024], *cp;
          |                      ^~
    
    Move it to local scope.

commit 49210f5e2df6b11865b3cc5e52329b93f6df4901
Author: Kuzin Andrey <kuzinandrey@yandex.ru>
Date:   Tue Nov 11 16:23:42 2025 +0300

    Fix: Possible unix socket path overflow with strncpy()
    
    Compilation warning:
    
    sd-daemon.c: In function 'netsnmp_sd_notify':
    sd-daemon.c:316:9: warning: '__builtin_strncpy' specified bound 108 equals destination size [-Wstringop-truncation]
      316 |         strncpy(sockaddr.un.sun_path, e, sizeof(sockaddr.un.sun_path));
          |         ^

commit 8a0608a37aaacfeb22faf5097d3bf227831990ec
Author: Kuzin Andrey <kuzinandrey@yandex.ru>
Date:   Tue Nov 11 16:22:56 2025 +0300

    Fix: Add wrapers on const values to use in hosts_ctl()
    
    To prevent compilation warnings in snmp_agent.c and snmptrapd.c about discard 'const' qualifier:
    
    snmp_agent.c:1082:29: warning: passing argument 2 of 'hosts_ctl' discards 'const' qualifier from pointer target type [-Wdiscarded-qualifiers]
     1082 |         if (hosts_ctl(name, STRING_UNKNOWN, sbuf, STRING_UNKNOWN)) {
          |                             ^~~~~~~~~~~~~~
    In file included from snmp_agent.c:94:
    /usr/include/tcpd.h:131:42: note: expected 'char *' but argument is of type 'const char *'
      131 | extern int hosts_ctl(char *daemon, char *client_name, char *client_addr,
          |                                    ~~~~~~^~~~~~~~~~~
    snmp_agent.c:1082:51: warning: passing argument 4 of 'hosts_ctl' discards 'const' qualifier from pointer target type [-Wdiscarded-qualifiers]
     1082 |         if (hosts_ctl(name, STRING_UNKNOWN, sbuf, STRING_UNKNOWN)) {
          |                                                   ^~~~~~~~~~~~~~
    /usr/include/tcpd.h:132:23: note: expected 'char *' but argument is of type 'const char *'
      132 |                 char *client_user);
          |                 ~~~~~~^~~~~~~~~~~

commit 311171416e4da6a1561bbab6e8cbe5291ad1b7ea
Author: Anton Moryakov <ant.v.moryakov@gmail.com>
Date:   Tue Nov 4 21:38:52 2025 +0300

    fix prevent buffer overflow in ASN_OCTET_STR index allocation
    
    In register_index(), when generating sequential string indices from
    'prev_idx_ptr', the code used a flawed algorithm that could lead to
    buffer overflow by writing beyond the end of new_index->varbind->buf.
    
    The loop condition relied on buf[i] without proper bounds checking,
    and the fallback logic for growing the string wrote to buf[i+1]
    without validating available space.
    
    Rewrite the octet string increment logic to:
    - Properly check array bounds using i >= 0
    - Use memmove to shift string left when growing
    - Validate buffer capacity before extending
    - Update val_len correctly
    
    Now returns NULL if buffer is full, preventing memor
    
    Signed-off-by: Anton Moryakov <ant.v.moryakov@gmail.com>

commit 201f8198c60b716c7c9dee6fe63cbbbc3838295b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Nov 9 06:18:18 2025 -0800

    snmptrapd: Fix an integer overflow
    
    Do not add one to the trap type if doing this would cause an integer overflow.
    
    Fixes: https://issues.oss-fuzz.com/issues/459029273

commit b4e6f826d9ddcc2d72eac432746807e1234266db
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Nov 2 14:48:55 2025 -0800

    snmptrapd: Fix out-of-bounds trapOid[] accesses
    
    Fixes: https://issues.oss-fuzz.com/issues/457106694
    Fixes: https://issues.oss-fuzz.com/issues/458668421
    Fixes: https://issues.oss-fuzz.com/issues/458876071

commit d49392bb982954aa3d31516f04b2d9784b5f204a
Author: Anton Moryakov <ant.v.moryakov@gmail.com>
Date:   Tue Nov 4 14:40:09 2025 +0300

    libsnmp: Reject invalid input in asn_realloc_rbuild_string()
    
    Return error if str == NULL && strlength != 0 in asn_realloc_rbuild_string
    to prevent potential NULL dereference and enforce valid input.
    
    Signed-off-by: Anton Moryakov <ant.v.moryakov@gmail.com>
    [ bvanassche: modified patch description ]

commit fc35391bb9d774d2ffa221df934a8ffdac91994b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Nov 2 15:17:48 2025 -0800

    snmplib/snmpksm: Free memory when exiting

commit 35d216b57ea2e9abf1cc42077bcf60a4bae0b29e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Nov 1 13:47:37 2025 -0700

    snmptrapd: Do not write outside the bounds of trapOid[]

commit b1f75132b1ed51743c862564065792fe20819b84
Author: wangxiaomeng <wangxiaomeng@kylinos.cn>
Date:   Fri Oct 31 11:18:53 2025 +0800

    libsnmp: Need check env_var before read mib

commit 1ef83cd90c65fae94debaed124d431d090813a1c
Author: wangxiaomeng <wangxiaomeng@kylinos.cn>
Date:   Thu Oct 30 14:27:52 2025 +0800

    snmp_agent.c: Fix crash caused by buf being a null pointer

commit 8683cca83726ca0159ff9450f4673e0e0fc4d2d2
Author: Wes Hardaker <opensource@hardakers.net>
Date:   Fri Dec 19 05:56:16 2025 -0800

    check trap variable type to ensure it's an OID

commit e3c550b890b249c3512063ee471b8a3067ec3d24
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Oct 14 20:28:16 2025 -0700

    ci, Windows: Bump the OpenSSL version number

commit 6592b9b64950ef2d38af0d7de4cff81d571b0b18
Author: Ryan Steinmetz <zi@FreeBSD.org>
Date:   Sat Sep 27 09:42:09 2025 +0200

    Fix build for FreeBSD 15.
    Patch taken from FreeBSD ports collection.

commit c8332ca8cce7e49189981066010b9e80e215aa0e
Author: GenericRikka <rikka.goering@outlook.de>
Date:   Thu Sep 11 02:50:40 2025 +0200

    Added include/net-snmp/system/freebsd16.h
    
    (cherry picked from commit 106cac2f04fc40c7f7a0f813b4bee88693dd9402)

commit f3a3e9fb98e428c2d974cf4b6ad7ec15bc188340
Author: Moshe Kaplan <mosheekaplan@gmail.com>
Date:   Thu Jul 24 13:27:50 2025 -0400

    tunnel.c: Avoid leaking tunnel->ifname
    
    Fixes coverity 454603
    (cherry picked from commit afd81d3965b9feb8f24e1e02c4e8e3b334693c58)

commit 79c453845aabb99bf2278db9c95633e35a6cc6d9
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 22 16:10:58 2025 -0700

    Perl: add the compiler flag -Wno-old-style-definition
    
    (cherry picked from commit 02bee0fe32a4136ade3de137eef6c5acdfeed508)

commit e5e1f96ded3d4f30d1ca223a80b9b0df6dc27115
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jun 22 16:00:51 2025 -0700

    snmpd, testing: Fix a few MinGW compiler warnings
    
    (cherry picked from commit dcabf00b29245249b717309957c0db6e232f1a0c)

commit ad4537a2af54d85772496c3f542f60c1a8eb7e69
Author: AntonMoryakov <ant.v.moryakov@gmail.com>
Date:   Tue Jun 10 13:54:26 2025 +0300

    loadave.c: fix out-of-bounds access in loadave_parse_config
    
    Static analysis reported a potential buffer overflow when accessing maxload[i - 1] for i = 0.
    
    The issue was fixed by:
    - Adding a check to ensure i > 0 before accessing maxload[i - 1]
    - Using NETSNMP_DEFMAXLOADAVE as a default value for the first element (i == 0)
    - Ensuring that the code does not attempt to access memory outside of the maxload array
    
    This change makes the code more robust and avoids undefined behavior.
    
    Signed-off-by: Anton Moryakov <ant.v.moryakov@gmail.com>
    (cherry picked from commit be3f27119346acbcc2e200bb6e33e98677a47b2d)

commit 604ebdc0b3f841f613572dc4e9cc161b2d3d587c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Jun 5 09:00:45 2025 +0800

    testing: Add a registration handler test with context name
    
    (cherry picked from commit 7a55b3332037302c4fd7d5378d435318704834a4)

commit bd5539a5757f172adcb5b504ec069b8f5ad396ee
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jun 9 16:07:51 2025 -0700

    snmpd: Fix a use-after-free in unregister_mib_context()
    
    See also https://github.com/net-snmp/net-snmp/issues/983.
    
    (cherry picked from commit b64bde54177ff2ed3110febcef189b5fdccb47ff)

commit fbc1b7f94ea4fa8d1853df9ab08f4a21fa125f2b
Author: Demon <hyh19962008@gmail.com>
Date:   Tue Jun 3 21:26:43 2025 +0800

    win32: add build support for Windows on ARM
    
    (cherry picked from commit 23cfd15bf05aad242af958831b2b472e24e0ce04)

commit 1a6aab4c913a505905ba8de1f2f4943e2f561d84
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Sep 13 15:29:08 2025 -0700

    ci: Switch to the latest version of the Android SDK

commit bcc2cccf6ecf0ebf2ec684c3854da9cfb6f8fc3b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Jun 20 10:59:29 2025 -0700

    MinGW64: ci/build.sh: Switch from pkg-config to pkgconf
    
    pkgconf is the preferred and modern choice for MinGW64.

commit e71597f537eeefe9c585be40262759e61cb9b4ce
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jun 2 15:48:35 2025 +0800

    Revert "snmpd: Exclude certain MIBs if the Netlink library is not available"
    
    This reverts commit a6042e0f08e3b70cc0e3d810ba120d86758f27d8.
    
    On the V5-9-patches branch, fewer MIBs depend on libnl than on the master
    branch. Hence this revert.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/980

commit b88a7334a1468daebff0d1d763a0a7d26e7e701d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 31 12:18:48 2025 -0700

    snmpd, Perl: Fix most compiler warnings for MODE=read-only
    
    This patch includes only one functional change, namely in the Perl function
    snmp_set(). This patch prevents that in read-only mode snmp_set() passes an
    uninitialized pointer to Safefree().

commit 0687955e879d916f8edd567763e088d2e7c37603
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 28 08:36:12 2025 -0700

    ci/build.sh: Dump config.log if configure fails

commit d4af272b3f3d7119c7ffa305fc2de6e8b7333c9b
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Wed May 28 16:48:10 2025 +0200

    Fix warning when compiling with --disable-ipv6

commit 573e3215057cfbc7bff22a13c72a0b8979434830
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 25 14:52:56 2025 -0700

    ci: Add MODE=without-nl

commit a6042e0f08e3b70cc0e3d810ba120d86758f27d8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 23 15:08:12 2025 -0700

    snmpd: Exclude certain MIBs if the Netlink library is not available
    
    On Linux a significant number of MIB implementations depends on the Netlink
    library. Exclude these MIBs if the Netlink library is not available.

commit e185504a84fff20fbc31ebbc24f8fbc15ae44eb1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 24 15:46:00 2025 -0700

    configure: Test earlier for the Netlink library
    
    Prepare for making the MIB choice dependent on the presence of the Netlink
    library.

commit 29faa0ccb8d93f561af878da3e7baf0979fcf3b1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri May 23 14:11:45 2025 -0700

    configure: Exit with exit code 1 if MIB module debugging is enabled
    
    No Makefile is generated if MIB module debugging is enabled. Hence exit with
    exit code 1.

commit 7182fb805a38910a85b0810e569ae19bf3786fbf
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun May 25 14:27:24 2025 -0700

    ci/build.sh: Query the branch name instead of hard-coding it

commit 628ccedea713287484dbed91fe698e313ec6d812
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat May 17 14:45:18 2025 +0000

    apps, snmpd: Move declarations in front of statements
    
    (cherry picked from commit 4473ead5cdecaa6df23a10062a701acaef61c299)

commit 2588df7628d423558afec54296b3d419e48dfac5
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 22 08:58:56 2025 -0700

    configure: Fix the -Wdeclaration-after-statement test

commit af34dcbe34fc5a825787a2157aed47d8e2e8bd8c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 21 16:18:40 2025 -0700

    ci: Add MODE=disable-ipv6

commit 0c0e19346e57287367e5baa3c60f1617c91a9819
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 21 16:42:12 2025 -0700

    testing: Skip IPv6 tests if IPv6 support is disabled

commit a1ec55476213f92915d8186e6cb793d562e9a733
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed May 21 16:27:18 2025 -0700

    libsnmp: Fix --disable-ipv6 support

commit 7536a8d6d363898e0f511aa81cf2dc000c452b89
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 15 13:25:09 2025 -0700

    configure: Enable -Wdeclaration-after-statement

commit d9aad5695ed8964c142867a6d7888c9dd90c7361
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 15 15:03:04 2025 -0700

    libsnmp, perl, apps: Fix -Wdeclaration-after-statement warnings

commit 5e2e029b262a3cba48ae801c259b85c5c749b013
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 15 08:47:53 2025 -0700

    ci/build.sh: Only build fuzz-tests on the master branch

commit d896cdd5d554ba06e09ae5a8777b917be9fd113e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu May 15 08:38:30 2025 -0700

    ci/net-snmp-configure: Add missing package names

commit 414394bddea52eafcae65e7bd7b0563c295b614d
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 8 13:48:16 2025 -0800

    ci/build.sh: Fix the CI build
    
    Only build the fuzz tests in regular mode. Fix the name of the Makefile target.
    
    Fixes: 8c9ec0108c24 ("move fuzz-test target to just inside testing")

commit c0cb4ef50ef2eff6006de47218f1d0db345e808e
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu May 15 16:09:54 2025 +0200

    testing: Fix OpenBSD warnings about strcpy(), sprintf() when running tests
    
    [ bvanassche: modified patch description / added parentheses around sizeof arguments ]

commit ed24f12728587737f5f8c08da1f171901cf9709b
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Thu May 15 16:07:39 2025 +0200

    libsnmp: Use libssh2_session_handshake() when available
    
    libssh2 v1.2.8 deprecated libssh2_session_startup,
    use libssh2_session_handshake when available.
    
    [ bvanassche: modified patch description ]

commit 741eb2dcfecf560a39454c7b93d56dff9a89a7c4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Thu Apr 3 19:57:37 2025 -0700

    libsnmp: Do not truncate AGENT-CAPABILITIES descriptions
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/957
    (cherry picked from commit 36e0bdd1a0e6c9073c2da6c837ecfc38c4854586)

commit c6ad7dffd7d81e5d603722a5053a3aed51cf5512
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Apr 1 09:48:26 2025 -0700

    Perl: Revert "fix resource leaks in the SNMP::Session destructor and SNMP::NODE::FETCH"
    
    Revert commit 581698a162b47b08f8571c7e1b8991df0764e5d3 because it introduced
    the following crash:
    
    __snmp_xs_cb (SNMP.so + 0xab9c)
    snmp_sess_close (libnetsnmp.so.40 + 0x39419)
    XS_SnmpSessionPtr_DESTROY (SNMP.so + 0x16dc0)
    Perl_pp_entersub (libperl.so.5.32 + 0x108437)
    Perl_call_sv (libperl.so.5.32 + 0x7b18a)
    S_curse.lto_priv.0 (libperl.so.5.32 + 0x110920)
    Perl_sv_clear (libperl.so.5.32 + 0x111068)
    Perl_sv_free2 (libperl.so.5.32 + 0x10ff52)
    Perl_free_tmps (libperl.so.5.32 + 0x13a66f)
    XS_SNMP__main_loop (SNMP.so + 0x17e97)
    Perl_pp_entersub (libperl.so.5.32 + 0x108437)
    Perl_runops_standard (libperl.so.5.32 + 0x1001a0)
    perl_run (libperl.so.5.32 + 0x7e90c)
    main (perl + 0x134a)
    __libc_start_call_main (libc.so.6 + 0x295d0)
    __libc_start_main@@GLIBC_2.34 (libc.so.6 + 0x29680)
    _start (perl + 0x1385)
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/955
    (cherry picked from commit 823b8d2eca1916ae80295959d2704b546d6a0006)

commit 656e39a2fe7125bf8c37a24e78427d5a373a8f7d
Author: Klaus Holst Jacobsen <klaus.jacobsen.ext@siemensgamesa.com>
Date:   Fri Mar 28 10:01:07 2025 +0100

    Better testing for syslog.h presence
    
    (cherry picked from commit 695ac0e1f8964e441d17282d9c475cc548f56f5d)

commit 9870561812c4f15e7ca63ea1b5e5db7d25b66708
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Mar 31 09:58:35 2025 -0700

    Perl: Suppress a warning message
    
    Suppress the following warning message:
    
    Attempt to call undefined import method with arguments ("AF_INET6" ...)
    via package "Socket6" (Perhaps you forgot to load the package?) at (eval 5)
    line 1.
    
    Fixes: https://github.com/net-snmp/net-snmp/issues/954

commit 19f0bb03152c2449b59663376958496edffe1531
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Mon Mar 17 16:36:04 2025 +0100

    Add error checking to schedConf.c.
    
    This fixes issue #864 (Out-of-bounds access in _sched_convert_bits
    function due to invalid cron_spec input)

commit 49ee547aad51dc716aca6b2390f8fe430a0a7723
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Mar 8 13:49:16 2025 -0800

    libsnmp: Fix a memory leak in an error path of parse_enumlist()
    
    Fixes: https://issues.oss-fuzz.com/issues/401658592
    (cherry picked from commit 4618b65571b44591418d2080b2b4aa6ba43e2291)

commit 48aaf0905d7fcafbc6ccc7f227958e08260e2ce3
Author: Anton Moryakov <ant.v.moryakov@gmail.com>
Date:   Tue Feb 4 00:04:16 2025 +0300

    agent: mibgroup: mibII: fix prevent use-after-free in write_vacmAccessStatus
    
    (cherry picked from commit 96faf0eb33e647916b6c3817ddda6dd02c7c4f25)

commit 595f9af35731461c276b716d21414fad50370056
Author: Maxim Korotkov <korotkov.maxim.s@gmail.com>
Date:   Wed Mar 5 12:36:15 2025 +0300

    snmplib: add deallocation of container name
    The function netsnmp_binary_array_release() does not deallocate dynamic char array.
    
    (cherry picked from commit dc2842c37a2ffbd26433c55c0de103251564944b)

commit b2802e60ee381a774ff85ea59000f432b9621353
Author: Stuart Henderson <stu@spacehopper.org>
Date:   Sat Mar 8 13:10:11 2025 +0000

    support openbsd8
    
    (cherry picked from commit 7ffa1ced101b45fd2d45ea7ffb6a6353b9ab5186)

commit 98c1925cb1221f25c5fc53960fa122c5ed314239
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Mar 5 19:33:33 2025 -0800

    Perl: Disable -Wmaybe-uninitialized for .xs files
    
    (cherry picked from commit d5254345f45f0c15e961e37b5f6a8194b004183d)

commit 9ae0e684c050c06fe0426bf821677a11d234dd05
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Mar 4 06:18:57 2025 -0800

    libsnmp: Fix a memory leak in the MIB parser
    
    Fixes: https://issues.oss-fuzz.com/issues/383154227
    (cherry picked from commit 2ee581b2ece557069e0f5a2e5cd65e3e6bf415c1)

commit 0532cb5af7f2460fd14d697ccd3ddf987aaa63ab
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Mar 3 12:18:50 2025 -0800

    testing/fulltests/unit-tests/T004snmp_enum_clib: Add more checks
    
    (cherry picked from commit 2e98a911a994e7ce18c9a0f0051549a9dbd64842)

commit 237a8377c8ee8af3e59b3cef96cfeb68f08dba4f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Mar 3 12:18:34 2025 -0800

    libsnmp: Make clear_snmp_enum() free all lists
    
    Fixes: 2da22610f90b ("libsnmp: Make init_snmp_enum() faster")
    (cherry picked from commit 1d0895eaf1b919ea63da2e6d51e9fd138b38b8dc)

commit 22c70efcc08f0da2525bc5d8f922ff99dfa4777b
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Mar 3 09:42:50 2025 -0800

    libsnmp: Rework se_add_pair_to_slist()
    
    Call se_add_pair_to_list() after having inserted 'sptr' into 'sliststorage'
    instead of before.
    
    (cherry picked from commit 080bcc445b67cd9dfc5c9f579182529aedbdf968)

commit 31546ccaad857e28dcc7f214f363a2a3efaba145
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Mar 3 09:24:02 2025 -0800

    libsnmp: Fix a memory leak in se_add_pair_to_list()
    
    Fixes: https://issues.oss-fuzz.com/issues/398401924
    (cherry picked from commit 2ed9186eb0473c6d4b72503d764f7b13ab1573ff)

commit 8a5d51e627173dfde092f2a32aca6fe2ebf602f6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 2 15:36:04 2025 -0800

    libsnmp: Fix a NULL pointer dereference in snmp_config_when()
    
    (cherry picked from commit 87bd1ec3620c37ff4e7602c13966d65371378244)

commit 9f6de1c98e04ddb4f254fc25f3cd7779d001a274
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 2 15:23:07 2025 -0800

    libsnmp: Fix a buffer overflow
    
    Fixes: https://issues.oss-fuzz.com/issues/399458050
    (cherry picked from commit 4082593d733e2e03aaac74c62801f76449402651)

commit 69b6025ab60ea67e0cfc7f37938d343149dedd63
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Mar 2 15:12:24 2025 -0800

    libsnmp: Use netsnmp_memdup() instead of open-coding it
    
    (cherry picked from commit e49ee4990168e9aa02a2aeb02857385f868ff948)

commit b7d5bbbb84239f0c22b5c227344b0a6a535cfd69
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Feb 25 13:04:11 2025 -0800

    libsnmp: Make init_snmp_enum() faster
    
    Call calloc() once instead of 5 * 32 + 1 = 161 times.
    
    (cherry picked from commit 2da22610f90b8a64c930af02d88f07f3a596905f)

commit 781e1bc319d23c61a00e62297b8926a866aaa6fd
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Feb 25 09:20:34 2025 -0800

    libsnmp: Fix a buffer overflow in setup_engineID()
    
    The following code triggers a buffer overflow if an oldEngineID has been
    specified that is shorter than 4 bytes:
    
      if (localEngineIDType == ENGINEID_TYPE_NETSNMP_RND)
        memcpy(bufp, &netsnmpoid, sizeof(netsnmpoid));   /* XXX Must be 4 bytes! */
      else
        memcpy(bufp, &enterpriseid, sizeof(enterpriseid)); /* XXX Must be 4 bytes! */
    
    Fix this by rejecting oldEngineID's shorter than four bytes.
    
    (cherry picked from commit 0b49a5de9ad4c3875e42ea223ff61de7d3e26963)

commit 2985da1608f6731906944c4018fefe73b91997b7
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Feb 24 12:12:08 2025 -0800

    libsnmp: Fix a heap buffer overflow in se_find_list()
    
    Fixes: https://issues.oss-fuzz.com/issues/398356443
    Fixes: d7e6be1d59f7 ("generic snmp enum list support")
    (cherry picked from commit a147b834d49e656f6216701b8769b4b6261e72d5)

commit 0b37269ca32393aeb314b2b726a345960701b464
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Feb 24 12:11:22 2025 -0800

    libsnmp: Declare local variables 'static'
    
    (cherry picked from commit 8305b51e4d80158052b9cc279b798c227d81b9af)

commit d845bdd100f454caf0bfd8ef28cf421d8fb26c16
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Feb 24 11:03:13 2025 -0800

    libsnmp: Simplify se_add_pair()
    
    Introduce se_find_list_ptr(). Simplify se_add_pair(). Remove se_store_in_list()
    because this patch removes the last user of that function. No functionality has
    been changed.
    
    (cherry picked from commit 5f79b7f37febd7fafbddcc0f2aff3e81a3a439a2)

commit 6a955cac13afa9ed9cdc778c7961756108259490
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Feb 23 10:10:15 2025 -0800

    libsnmp: Simplify se_add_pair_to_list()
    
    Move the memory allocation code in front of an if-statement instead of
    duplicating it in each branch of that if-statement.
    
    (cherry picked from commit f23617df54f4d09d346bbc3452528abe3cc7947e)

commit 61325b5cae0e5b2243fc078c6da71924dad0fa11
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Feb 23 10:01:12 2025 -0800

    libsnmp: Make 'optind' handling more robust
    
    Fixes: https://issues.oss-fuzz.com/issues/398067543
    (cherry picked from commit 2b3e0837830e14c7747ac1e175017c733d9d62b3)

commit 90d06e589b77c3875595716700d69f6b6c4136f1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 21 15:04:30 2025 -0800

    libsnmp: Fix another stack buffer overflow in se_read_conf()
    
    Additionally, make some recently modified code easier to read.
    
    Fixes: https://oss-fuzz.com/issue/6271135411142656
    (cherry picked from commit b4d94476f02769a92be7d2122bc8926f39aa6980)

commit 6af1dd2e6ab3820d949e24bc640bdcd75a05e48f
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Feb 18 06:31:10 2025 -0800

    libsnmp: Fix the code for resetting getopt()
    
    Although the getopt() man page mentions that 'optind' should be set to
    1 to reset getopt(), the glibc implementation only resets the getopt()
    state if 'optind' is set to zero.
    
    Fixes: https://issues.oss-fuzz.com/issues/396777457
    (cherry picked from commit cbedf0cba170b967ab312ebc794eabdd6f67c6d5)

commit d1372b63fdf0d7fceb67c9527cf31d1219f84da0
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Feb 16 13:31:48 2025 -0800

    Perl: SNMP: Suppress a compiler warning
    
    Suppress the following Clang compiler warning:
    
    SNMP.xs: In function ‘__snprint_value.isra’:
    SNMP.xs:449:21: warning: argument 1 is null but the corresponding size argument 3 value is [4095, 4096] [-Wnonnull]
      449 |                     strlcpy(buf, ep->label, buf_len);
          |                     ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    In file included from /usr/lib/x86_64-linux-gnu/perl/5.38/CORE/perl.h:1715,
                     from SNMP.xs:12:
    /usr/include/string.h:506:15: note: in a call to function ‘strlcpy’ declared with attribute ‘access (write_only, 1, 3)’
      506 | extern size_t strlcpy (char *__restrict __dest,
          |               ^~~~~~~
    
    (cherry picked from commit 562a8bba9ebbc8621b8c299db6264c2d5685a721)

commit c1ae498b04cdc43ebb6e5348dcf51fe061c1dec4
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Feb 16 08:45:02 2025 -0800

    libsnmp: Fix a stack buffer overflow in se_read_conf()
    
    Fixes: https://issues.oss-fuzz.com/issues/396958482
    (cherry picked from commit 2342de96b4968969e2f01f3970905963053b0504)

commit 858157c225f8db6e41683a154b30f557a1501e5c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Feb 16 07:56:17 2025 -0800

    libsnmp: Fix a NULL pointer dereference in netsnmp_ds_handle_config()
    
    This has been detected by fuzzing netsnmp_parse_args().
    
    (cherry picked from commit 0a08ddf75e2234ea93aed1b2bccd9e387444e69b)

commit e2712fe7e0d3dabb340c3770c27f233361fae6a1
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Feb 16 07:51:11 2025 -0800

    libsnmp: Fix missing argument handling in netsnmp_parse_args()
    
    This may fix https://oss-fuzz.com/issue/4664325096931328 (not sure).
    
    (cherry picked from commit 578b1f50062677d6db1dc0e134226457b627ea11)

commit 44c2edb218c303d0fc5f8e83483887246dfac749
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Feb 15 19:02:12 2025 -0800

    libsnmp: Fix an out-of-bounds access in netsnmp_hex_to_binary()
    
    isxdigit() accepts arguments in the range -1..255. Make sure that the value
    passed to isxdigit() is in that range. This has been found by reading the
    source code.
    
    (cherry picked from commit ed6247a54085c13b1c327e46afe73d248e6afef0)

commit 007b9c7e8a77c0b8b7e761895517923b00923304
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Fri Feb 14 08:01:36 2025 -0800

    libsnmp: Fix a memory leak in netsnmp_transport_filter_add()
    
    Fixes: https://issues.oss-fuzz.com/issues/396459485
    (cherry picked from commit db989be9abc201d60691a0926e5a76f66f843fc3)

commit 5c27b38d84cd480a0dc1dc09e93ce78e4663b99c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Feb 12 15:49:24 2025 -0800

    libsnmp: Fix a NULL pointer dereference in netsnmp_ds_parse_boolean()
    
    Fixes: https://issues.oss-fuzz.com/issues/395969086
    (cherry picked from commit 930f44e2ef4972047f3394c28c655fd15e04c706)

commit e02bab233ca1ccff6b90eda7b644967c7b6917de
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Feb 12 15:45:58 2025 -0800

    libsnmp: Fix an out-of-bounds access in snmp_log_options()
    
    Fixes: https://issues.oss-fuzz.com/issues/395921931
    (cherry picked from commit c90280f310aa8f9fd0442128244a8672bdfdb80e)

commit 0b3d8eeba0df795676754ae7207726d3efb38a2e
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Feb 12 15:41:35 2025 -0800

    libsnmp: Fix a memory leak in netsnmp_parse_args()
    
    Fixes: https://issues.oss-fuzz.com/issues/395969087
    (cherry picked from commit 0ab82d4c6cae3dd9f901ae292c2f60bbea32515a)

commit 9c2aeb5cb12a75f366303623c522f6ed72afd944
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Feb 12 07:35:48 2025 -0800

    libsnmp: Fix a heap buffer overflow
    
    Fixes: https://issues.oss-fuzz.com/issues/396102403
    (cherry picked from commit 50d5c3d007cf9b4f56a29b79a8a2e736115eb6cb)

commit c58525e2cfc4c18c8ccf51345f9b523b9507ad8a
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Feb 12 07:30:44 2025 -0800

    libsnmp: Declare local functions 'static'
    
    (cherry picked from commit 8cf375fb612dcaa635a063d92b962be260a6a0ea)

commit 6644fd92260abedf52921101419bc3f341fddeb8
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Feb 12 09:13:27 2025 -0800

    ci, Windows: Bump the OpenSSL version number

commit bdb611307f1fa9336b9455409e748bf709f31677
Author: Egil Kvaleberg <egil@jualako.com>
Date:   Fri Jan 31 21:26:37 2025 +0100

    Document that we are now using configure.ac
    
    (cherry picked from commit 1109b6fd408e1c8b03e6ccfdcbe70c2ad0412c13)

commit 8d4f4d623f5f90ad7ca7227a1cacce23a0e52802
Author: Egil Kvaleberg <egil@jualako.com>
Date:   Fri Jan 31 21:24:20 2025 +0100

    Avoid latest Rpi compiler complaining about possibly uninitialized variable.
    The code seems ok.
    
    (cherry picked from commit 5db02cfd10b4a198cfcd23658f17f0d8f737a8ab)

commit 3d41fcf7eb0d4590a6583fa024d27cd7fc75f6fa
Author: Yuan <zodf0055980@gmail.com>
Date:   Wed Jan 22 16:31:47 2025 +0800

    Fix include stdint.h missing to get SIZE_MAX
    
    This fixes commit d33578d for ubuntu building.
    
    Signed-off-by: zodf0055980 <zodf0055980@gmail.com>
    (cherry picked from commit ba627e15aafd49341d94d35989b1b9703918dfa9)

commit a043a06540dc595dc17a56504de969d3700264f6
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Mon Jan 20 19:23:56 2025 -0800

    libsnmp: Fix an integer overflow in asn_parse_signed_int64()
    
    This was detected by Coverity (ID 454617).
    
    (cherry picked from commit 33b25d6e181ba949791885109a5dadeaa9046865)

commit eed6600c62ac18599cdf562db4cb0de1974b1f41
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jan 19 19:06:38 2025 -0800

    libsnmp: Simplify include/net-snmp/types.h
    
    (cherry picked from commit 6a95ad887b04758e5b76e5d3d0c8546257e5efd5)

commit eb9a6282d8ef14902c8f7ed1c9c9da43d0640fdb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sun Jan 19 19:15:26 2025 -0800

    libsnmp: Fix the netsnmp_gethomedir() declaration
    
    Fixes: 1c6e66b3122b ("libsnmp: Fix homedir lookup also for configuration")
    (cherry picked from commit 0e27a7d8c2f9c84fc641cc61cf24791da8a8198f)

commit 8067e9ff12fbf706323f3faef5b9146e57158b58
Author: Klaus Holst Jacobsen <klaus.jacobsen.ext@siemensgamesa.com>
Date:   Fri Jan 17 10:12:23 2025 +0100

    Added qnx support
    
    (cherry picked from commit 2145ebd07f5b6ec6c4eee505ffa2431f3c361087)

commit a1d35a12cdb62aa7c71866715843a38f64e0eefc
Author: Denis Kamenskii <dekamenskii@mail.ru>
Date:   Fri Oct 4 11:45:35 2024 +0300

    notificationFilter: Fix mask data copying
    
    This change is fixing incorrect filterMask copying when adding a new snmpNotifyFilter
    
    (cherry picked from commit 571696608c260d81d1d686234fea02a132bbe65a)

commit 0b940b98005498419d24d14fbdfb2137946d321c
Author: Jon DeVree <nuxi@vault24.org>
Date:   Sat Jan 18 10:04:03 2025 -0500

    Add missing 'diskio_exclude_md' to manpage
    
    Fixes: 2fc3de6b5 ("Added option to exclude *md* devices in diskio.")
    (cherry picked from commit bb21b69d75df050754efb5476e74eb4f630e5d11)

commit e29c40dbddb827e4b9324c0105cfc9a35e7557ac
Author: Jon DeVree <nuxi@vault24.org>
Date:   Sat Jan 18 10:03:18 2025 -0500

    Fix typo in manpage: LInux => Linux
    
    Additionally, ending a line with a period seems to insert an extra space
    into the resulting text. Re-wrap the line to avoid having a period as
    the last character.
    
    (cherry picked from commit dc7f4d53afd687b3a70ec0d16b80b8ced0afbac7)

commit e0fb35640459f62a7773cee09c34949b19d82a88
Author: Orgad Shaneh <orgad.shaneh@audiocodes.com>
Date:   Wed Dec 18 07:40:40 2024 +0200

    libsnmp: Fix homedir lookup also for configuration
    
    (cherry picked from commit 1c6e66b3122b7fd878d17f40664adf831d1a2c7a)

commit ef137dbd3c183db0acce4fcb60ab67245b092b26
Author: Niels Baggesen <nba@users.sourceforge.net>
Date:   Fri Jan 24 16:14:20 2025 +0100

    Normalized line endings

commit a17027209a0101b66dc7ab50670d0146677e2545
Author: Orgad Shaneh <orgad.shaneh@audiocodes.com>
Date:   Tue Dec 17 12:03:57 2024 +0200

    Add gitattributes file to use eol=lf for almost all files
    
    This fixes autoreconf on MSYS2 and possibly other issues.
    
    (cherry picked from commit d17282ed842364d83be83d1a45ad95dd986cdb0a)

commit 572661f8265516c397b7691aa4ae1b8cfa05a34b
Author: Orgad Shaneh <orgad.shaneh@audiocodes.com>
Date:   Tue Dec 17 20:59:59 2024 +0200

    libsnmp: Support $HOME in MIBDIRS also on Windows
    
    (cherry picked from commit 75829eb857f2468001050fda26af843bcb9475db)

commit 5a94f2831e8b22ffd962af9db6f7d0959c0dde51
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 11 07:56:25 2024 -0800

    libsnmp: Use asprintf() in parse_trapDefinition()
    
    No functionality has been changed.
    
    (cherry picked from commit 46980afe4a4b5ce9820bd4419064d18e28fe215b)

commit b7119b2d578e782300d372a2e5e1c6327977e2eb
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Wed Dec 11 07:21:17 2024 -0800

    snmplib/parse.c: Make error handling more systematic
    
    No functionality has been changed.
    
    (cherry picked from commit b057efbf770fbd964a8f6fd1e27912f584a6a8ee)

commit 078e165b17376e95c705341affad628e86d865ac
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 7 15:13:29 2024 -0800

    libsnmp: Fix a memory leak in free_objgroup()
    
    Fixes: 84aba8f8f878 ("libsnmp: Fix a memory leak in the MIB parser")
    Fixes: https://issues.oss-fuzz.com/issues/380322456
    (cherry picked from commit 9425b05b663c55e12bc4fccec45a520c333ee343)

commit d6e918eadc41eb3a364ce946495e92151221b63c
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Sat Dec 7 15:09:09 2024 -0800

    libsnmp: Clean up compliance_lookup()
    
    Convert an if-else statement into an early return. Remove a superfluous
    cast.
    
    (cherry picked from commit d1bf740f9d328c2264f7a0abfb1970f41ccf9c4e)

commit 11169c7d027b61150cda413a48bae62a36364723
Author: Bart Van Assche <bvanassche@acm.org>
Date:   Tue Dec 3 09:26:40 2024 +0800

    MIB-II: Suppress a Coverity warning about an uninitialized variable
    
[--snip--]
